function testinit(self)
    self.CPUTeam = Activity.TEAM_2;
    for player = 0, self.PlayerCount - 1 do
        if not self:GetPlayerBrain(player) then
			local brain = CreateActor("Brain Case");
			brain.Pos.X = FrameMan.PlayerScreenWidth / 3;
			brain.Pos.Y = FrameMan.PlayerScreenHeight / 3;
			brain.GetsHitByMOs = false;
			MovableMan:AddActor(brain);
			self:SetPlayerBrain(actor, player);
		end
	end
end

function testalwaysrun(self)
	for player = 0, self.PlayerCount - 1 do
       	local team = self:GetTeamOfPlayer(player);
        local brain = self:GetPlayerBrain(player);
        if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
        	self:SetPlayerBrain(nil, player);
        	local newBrain = MovableMan:GetUnassignedBrain(team);
        	if newBrain then
           		self:SetPlayerBrain(newBrain, player);
			end
		end
	end
end

function Test:StartActivity()
	testinit(self);

    io = require("io");
    x = io.open("Tester.rte/Results.txt","w");
	x:write("CC PERFORMANCE TESTER V0.2 \nCOPYRIGHT 2010 GRIFFITH INDUSTRIES \n")
	x:write("OS: \nPROCESSOR: \nRAM: \n");
    x:write("RESX: ", tostring(FrameMan.PlayerScreenWidth));
	x:write("\nRESY: ", tostring(FrameMan.PlayerScreenHeight));
	x:write("\nPPM: ", FrameMan.PPM);
	x:write("\nPOSTPROCESSING: ", tostring(FrameMan.PostProcessing));
	local modules = PresetMan:GetTotalModuleCount();
	x:write("\nMOD COUNT: ", modules);
	x:write("\nTIMESCALE: ", TimerMan.TimeScale);
	x:write("\nDELTATIME: ", TimerMan.DeltaTimeSecs);

	self.justtested = false;
	self.timer = Timer();
	self.testtimer = Timer();
	self.testnumber,self.pre,self.post,self.sum = 0,0,0,0;
	self.test,self.testtype = 1,1;
	self.results = {};
	--.test is the global, 1-3 for particle, terrain, moid
	--.testtype is the specific branch of test within test
	--.testnumber is the specific test within the branch
end

function test(self)
	if self.test == 1 then
		for i = 1,(10 ^ self.testtype) do
			local pixel = CreateMOPixel("Grenade Fragment Gray");
			pixel.Pos.X = FrameMan.PlayerScreenWidth / 2;
			pixel.Pos.Y = FrameMan.PlayerScreenHeight / 2;
			pixel.Vel.X = math.random(-100,100);
			pixel.Vel.Y = math.random(-100,100);
			MovableMan:AddParticle(pixel);
		end
	end
end

function average(self)
	for i = 1,#self.results do
		self.sum = self.sum + self.results[i];
	end
	if self.sum > 0 then
		local avg = self.sum / #self.results;
		local newavg = avg * 100;
		local roundedavg = math.floor(newavg);
		local finalavg = roundedavg / 100;
		x:write("\nTEST RESULT ",(self.testtype - 1)," : " .. finalavg);
	end
end

function Test:UpdateActivity()
	if self.justtested == true then
		self.justtested = false;
		self.post = self.timer.ElapsedRealTimeMS;
		local diff = self.post - self.pre;
		--x:write("\nDifference MS during Test " .. self.test .. ": " .. diff);
		table.insert(self.results,diff);
	end
	if self.test == 1 then
		if self.testtype < 4 then
			if self.testnumber < 5 then
				if self.testtimer:IsPastSimMS(1000) == true then
					self.testtimer:Reset();
					test(self);
					self.testnumber = self.testnumber + 1;
					self.pre = self.timer.ElapsedRealTimeMS;
					self.justtested = true;
				end
			else
				self.testtype = self.testtype + 1;
				self.testnumber = 0;
				average(self);
				self.results = {};
			end
		else
			self.test = 0;
			x:close();
		end
	end

	testalwaysrun(self);
end
